#ifndef __ASPIFORCD_H__
#define __ASPIFORCD_H__

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <winbase.h>
#include <vector>
#include "wnaspi32.h"
#include "scsidefs.h"


class CAspiForCD
{
public:
	struct SMSF
	{
		BYTE m_minute;
		BYTE m_second;
		BYTE m_frame;
		friend bool operator ==(const SMSF& lhv, const SMSF& rhv)
		{
			if (lhv.m_minute==rhv.m_minute && lhv.m_second==rhv.m_second && lhv.m_frame==rhv.m_frame)
				return true;
			else
				return false;
		};
	};

	struct SDeviceInformation
	{
		BYTE m_host;
		BYTE m_id;
		char m_aVendorID[8 +1];
		char m_aProductID[16 +1];
		char m_aProductRevision[4 +1];
	};

	struct SStatus
	{
		BYTE m_status;
		BYTE m_key;
		BYTE m_asc;
		BYTE m_ascq;
	};

private:
	HANDLE m_hEvent;
	SStatus m_status;
	BYTE *m_pBuffer;

	CRITICAL_SECTION m_sync;

	HINSTANCE m_hWNASPI32;
	DWORD (__cdecl *m_pGetASPI32SupportInfo)();
	DWORD (__cdecl *m_pSendASPI32Command)(LPSRB);

	bool m_canUse;
	std::vector<SDeviceInformation> m_vDeviceInformarion;
	int m_currentDeviceIndex;

	BYTE getDeviceType(BYTE host, BYTE id);
	void getInquiryData(BYTE host, BYTE id, SDeviceInformation& data);
	void getMaxTarget(BYTE host, BYTE& num);

	//SCSI R}hsBm_status XVAs΁Atrue ԂB
	bool sendCDB(BYTE host, BYTE id, const BYTE *pCdb, BYTE cdbLength, WORD direction, WORD timeoutTimeSeconds);

public:
	CAspiForCD();
	~CAspiForCD();

	bool canUse();

	BYTE *getBuffer();
	DWORD getBufferSize();
	int getDeviceNumber();
	void scanDevice();
	bool getDeviceInformation(int index, SDeviceInformation& info);
	bool relationDevice(int index);
	bool sendCDB(const BYTE *pCdb, BYTE cdbLength, WORD direction=SRB_DIR_SCSI, WORD timeoutTimeSeconds=10);
	bool getStatus(SStatus& status);

	static bool lbaToMsf(long int lba, SMSF& msf);
	static bool msfToLba(SMSF msf, long int& lba);
	static bool addressToMsf(DWORD address, SMSF& msf);
	static bool msfToAddress(SMSF msf, DWORD& address);
};

#endif //__ASPIFORCD_H__