//	July 21, 2003  13:03

#include "StdAfx.h"
#include "AspiForCD.h"
#include "DeviceControl.h"

void enumDevice();
void procedure(int num, const char *pFilename);
void *createMMFile(const char *pFilename, int size, HANDLE *phFile, HANDLE *phMM);
void closeMMFile(HANDLE hFile, HANDLE hMM);

int main(int argc, char *argv[])
{
	int num;

	if (argc<=2)
	{
		printf(	"usage:\n"
				"%s num filename\n",
				argv[0]);
		enumDevice();
		return EXIT_SUCCESS;
	}

	num = atoi(argv[1]);
	procedure(num, argv[2]);

//procedure(0, "F:\\hoge");

	return EXIT_SUCCESS;
}

void enumDevice()
{
	CAspiForCD aspi;
	CAspiForCD::SDeviceInformation info;
	int i;

	if (!aspi.canUse())
		return;

	printf("num:  HA  ID  vendorID / productID / revision\n");
	for (i=0; i<aspi.getDeviceNumber(); i++)
	{
		aspi.getDeviceInformation(i, info);
		printf("%3d: %3d %3d   %s / %s / %s\n", i, info.m_host, info.m_id, info.m_aVendorID, info.m_aProductID, info.m_aProductRevision);
	}
}

void procedure(int num, const char *pFilename)
{
	CAspiForCD aspi;
	CDeviceControl ctl;
	long int capacity, addr;
	char aFilePathName[512];
	HANDLE hFileImg;
	HANDLE hMMImg;
	BYTE *pImg;
	int retryCnt;


	if (!aspi.canUse() || !aspi.relationDevice(num)) //FIX
		return;

	ctl.connectAspi(&aspi);


	ctl.getCapacity(capacity);
printf("capacity: %d\n", capacity);


	strcpy(aFilePathName, pFilename);
	strcat(aFilePathName, ".img");
	pImg = (BYTE *)createMMFile(aFilePathName, 2352*(capacity+1), &hFileImg, &hMMImg);
printf("img: %s\n", aFilePathName);


	for (addr=capacity; 0<=addr; addr--) //FIX: (T-T)/
	{
		printf("%6d\n", addr);
		retryCnt = 4;
		while (!ctl.readCD(addr, 1, 0xf8, 0x00, 1))
		{
			printf("failed `readCD'  addr: %d\n", addr);
			if (0 == --retryCnt) //FIX
			{
				printf("skip  addr: %d\n", addr);
				break;
			}
			Sleep(100);
		}

		memcpy(&pImg[2352*addr], aspi.getBuffer(), 2352);
	}

	closeMMFile(hFileImg, hMMImg);

	ctl.disconnectAspi();
}

void *createMMFile(const char *pFilename, int size, HANDLE *phFile, HANDLE *phMM)
{
	void *pRetVal;

	DeleteFile(pFilename);
	*phFile = CreateFile(pFilename, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
	*phMM = CreateFileMapping(*phFile, NULL, PAGE_READWRITE, 0, size, NULL);
	pRetVal = MapViewOfFile(*phMM, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	*(char *)pRetVal = 0;

	return pRetVal;
}

void closeMMFile(HANDLE hFile, HANDLE hMM)
{
	CloseHandle(hMM);
	CloseHandle(hFile);
}

